$(document).ready(function () {

    var objData = new Map();
    $("#viewfile").click(function ExportToTable() {
        var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.xlsx|.xls)$/;
        /*Checks whether the file is a valid excel file*/
        if (regex.test($("#excelfile").val().toLowerCase())) {
            var xlsxflag = false; /*Flag for checking whether excel is .xls format or .xlsx format*/
            if ($("#excelfile").val().toLowerCase().indexOf(".xlsx") > 0) {
                xlsxflag = true;
            }
            /*Checks whether the browser supports HTML5*/
            if (typeof (FileReader) != "undefined") {
                var reader = new FileReader();
                reader.onload = function (e) {
                    var data = e.target.result;
                    /*Converts the excel data in to object*/
                    if (xlsxflag) {
                        var workbook = XLSX.read(data, {
                            type: 'binary'
                        });
                    } else {
                        var workbook = XLS.read(data, {
                            type: 'binary'
                        });
                    }
                    /*Gets all the sheetnames of excel in to a variable*/
                    var sheet_name_list = workbook.SheetNames;

                    var cnt = 0; /*This is used for restricting the script to consider only first sheet of excel*/
                    sheet_name_list.forEach(function (y) {
                        /*Iterate through all sheets*/
                        /*Convert the cell value to Json*/
                        if (xlsxflag) {
                            var exceljson = XLSX.utils.sheet_to_json(workbook.Sheets[y]);
                        } else {
                            var exceljson = XLS.utils.sheet_to_row_object_array(workbook.Sheets[y]);
                        }
                        if (exceljson.length > 0 && cnt == 0) {
                            exceljson.sort(function (a, b) {  // storing excell raw data to find duplicateSiteId's.
                                if(a.siteId){
                                    var compairedValue=a.siteId.localeCompare(b.siteId);
                                 /*   if(compairedValue==0){ // if any duplicate enries find
                                        console.log(a);
                                        exceljson[count].duplicateEntry="true";
                                    }*/
                                return compairedValue;  
                                }
                            });
                            console.log(exceljson);
                            var dynamicClassObj = new DynamicTabledata(); // class in DynamicTable.js
                            var tableContent = dynamicClassObj.getDynamicTableContent(exceljson);
                            objData.set("dataFromExcel", exceljson);
                            //console.log(exceljson);
                            $("#exceltable").append(tableContent);
                            afterAppendRawDataToTableUi(exceljson);
                            //console.log(exceljson[0].siteId);
                            /*   for (var index = 0; index < exceljson.length; index++) {
                                   rawDataArray.push(exceljson[index]); // storing excell raw data in array formate.
                               }*/
                            /* console.log(rawArray[0].siteId);
                             rawArray[0].siteId="datta";
                             console.log(rawArray[0].siteId);*/
                            cnt++;
                        }


                    });





                    // $('#exceltable').show();
                }
                if (xlsxflag) {
                    /*If excel file is .xlsx extension than creates a Array Buffer from excel*/
                    reader.readAsArrayBuffer($("#excelfile")[0].files[0]);
                } else {
                    reader.readAsBinaryString($("#excelfile")[0].files[0]);
                }
            } else {
                alert("Sorry! Your browser does not support HTML5!");
            }
        } else {
            alert("Please upload a valid Excel file!");
        }
    });

    function afterAppendRawDataToTableUi(exceljson) {

        $(".customerNameDropDown").change(function () {

            var rowvalue = $(this).attr("data-rowIndex");
            $(this).siblings("span").remove();
            exceljson[rowvalue].customerName = $(this).val();
            console.log(exceljson[rowvalue].customerName);
            /*  for(var index=0;index<errorBucket.length;index++){
                   console.log(errorBucket[index].get("rowIndex")+"  "+rowvalue+"  customer="+errorBucket[index].get("cutomer")); 
                if(errorBucket[index].get("rowIndex")==rowvalue){*/
            //errorBucket[index].set("cutomer","noErrorFound");  
            /*  }
                  
            }*/
            errorBucket[rowvalue].set("cutomer", "noErrorFound");
            //removing error from errorBucket

        });
        $(".circleDropDown").change(function () {
            var rowvalue = $(this).attr("data-rowIndex");
            $(this).siblings("span").remove();
            exceljson[rowvalue].circle = $(this).val();
            // console.log(exceljson[rowvalue].circle);
            /*for(var index=0;index<errorBucket.length;index++){
                console.log(errorBucket[index].get("rowIndex")+"  "+rowvalue+"  circle="+errorBucket[index].get("circle"));
              if(errorBucket[index].get("rowIndex")==rowvalue){*/
            // errorBucket[index].set("circle","noErrorFound");  
            /* }
                  
            }*/
            errorBucket[rowvalue].set("circle", "noErrorFound");

        });
    }

    function errorValidation() {
        var returnValue = 'zeroErrors';
        for (var index = 0; index < errorBucket.length; index++) {
            if (errorBucket[index].get("siteId") == "Error" || errorBucket[index].get("siteName") == "Error" ||
                errorBucket[index].get("LatLong") == "Error" || errorBucket[index].get("cutomer") == "Error" ||
                errorBucket[index].get("circle") == "Error") {
                returnValue = errorBucket[index].get("rowIndex");
            }
        }
        console.log("returnValue " + returnValue);
        return returnValue;

    }



    $("#submit").click(function () {
        var checkError = errorValidation();
        if (checkError != 'zeroErrors') { // if any error found.
            var errorNavigator = $("#triggerAnchr");
            errorNavigator.attr("href", "#serialNumber" + checkError);
            errorNavigator[0].click();
        } else {
            console.log(errorBucket);
            var data = objData.get("dataFromExcel");
            //console.log(data);
            var excelRowDataArray = [];
            for (var index = 0; index < data.length; index++) {
                excelRowDataArray.push(JSON.stringify(data[index])); // making stringyfy of each SiteDetails.
                //array[index]=data[index];
                //console.log(data[index]);
            }
            /* objData.set("stringfyDataFromExcel", excelRowDataArray); // setting required Data in map
              console.log(excelRowDataArray);*/

            console.log(excelRowDataArray);
            var content = excelRowDataArray; // getting required Data from map
            //console.log(content);
            $.ajax({
                type: "POST",
                url: "http://192.168.1.126/PACS_FieldTravelAllowance_RestApi_V2/public/addSiteBulk",
                data: {
                    valueArray: content,
                    empid: "",
                    empName: ""
                },
                success: function (response) {
                    console.log(response);
                },
                error: function (error) {
                    console.log("error on getting response from API");
                }

            });
        }
    });
});



// ;;